QGIS Application - Bug report #13061
QGIS crashes on close if data was read through GDAL in Python Console
2015-07-02 01:35 AM - Radoslaw Guzinski

Status: Closed

Priority: High

Assignee:

Category: PyQGIS Console

Affected QGIS version:2.18.11 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corruptsdata: Copied to github as #: 21131
Description

To reproduce start QGIS, run the following in Python Console and then close QGIS:

from osgeo import gdal

inFilename = r"C:\\test.tif"

mylmg = gdal.Open(inFilename, gdal.GA_ReadOnly)
myBand = mylmg.GetRasterBand(1)

myData = myBand.ReadAsArray()

myData = None

myBand = None

mylmg = None

The crash happens around 90% of the time. The same happens when the code is run in a Processing script. If the data is not read (i.e.
"myData = myBand.ReadAsArray()" is removed) the crash does not occur.

Tested on 64 OSGeo4W installation of QGIS 2.8.2, 2.10 and nightly (commit:f3fe29d) on a number of Windows 7 machines.

History

#1 - 2015-07-31 11:24 AM - Giovanni Manghi

- Category set to PyQGIS Console

- Priority changed from Normal to High

- Crashes QGIS or corrupts data changed from No to Yes
#2 - 2015-11-19 06:32 AM - Casper Borgesen

| can verify that it still exists in MASTER commit:824fd7b

| found the issue seperately when instead of calling ReadAsArray(), | called WriteArray(...) in my python plugin. Without calling WriteArray(...) no minidump

is created on exit.

It happens in Windows 7, x64 running both OSGeo4W x64 MASTER and stand alone installer v. 2.12 x64 - both versions affected.

#3 - 2015-12-28 12:48 PM - Leonard Kong

| can verify that it still exists with QGIS 2.12. My plugin crashes in exactly the same location.
#4 - 2015-12-31 03:44 PM - Leonard Kong
This is a blocking issue for me, . . . | have been thinking that this is a gdal problem and | think most people looking at this think the same, . . . perhaps it's

not. Perhaps this is a QGIS problem in the function that is called on exit. Maybe there is an exception in that function that needs to be caught. Is that a
python function or is it a QGIS c++ call at that location?

#5 - 2016-01-03 05:01 AM - Giovanni Manghi
- Status changed from Open to Feedback
Leonard Kong wrote:
This is a blocking issue for me, . . . | have been thinking that this is a gdal problem and | think most people looking at this think the same, . . .

perhaps it's not. Perhaps this is a QGIS problem in the function that is called on exit. Maybe there is an exception in that function that needs to be
caught. Is that a python function or is it a QGIS c++ call at that location?

please raise this issue in the developers mailing list.

#6 - 2016-01-16 05:52 PM - Sebastian Dietrich

| can reproduce the crash using the mentioned Python code.

Under Windows, GDAL is quite picky with its memory, because it uses its own heap. Also ownership is an issue, e.g. delete myBand; would be an error in

C++. But we assume this is all properly taken care of in the python bindings.

As a workaround you can use ReadRaster() and WriteRaster(). The following code does not crash QGIS on exit under Windows:

from osgeo import gdal

inFilename = r"C:\\test.tif"

mylmg = gdal.Open(inFilename, gdal.GA_ReadOnly)
myBand = mylmg.GetRasterBand(1)

scanline = myBand.ReadRaster( 0, 0, myBand.XSize, 1, myBand.XSize, 1, gdal.GDT_Byte )
import array

array_of_bytes = array.array('B', scanline)

myBand = None
mylmg = None

#7 - 2016-02-03 12:03 AM - Sandro Santilli

Could you please try with the code in https://github.com/qgis/QGIS/pull/2755 ?

| cannot reproduce due to some problem with the python binding of gdal on my local system

#8 - 2016-02-03 12:21 AM - Sandro Santilli

| tried myself, this issue cannot be reproduced (for me) by using the code in https://github.com/qgis/QGIS/pull/2755

2025-06-08 2/5


https://trac.osgeo.org/gdal/wiki/FAQMiscellaneous#HowshouldIdeallocateresourcesacquaintedfromGDALonWindows
http://gdal.org/python/osgeo.gdal.Band-class.html
http://gdal.org/python/osgeo.gdal.Band-class.html
http://gdal.org/python/osgeo.gdal.Band-class.html
https://github.com/qgis/QGIS/pull/2755
https://github.com/qgis/QGIS/pull/2755

#9 - 2016-02-03 12:42 AM - Sandro Santilli

| actually cannot reproduce this with master branch either (as of commit:b6¢c714ac20ea595ebf3136ae8facae0520acbe5f)

Is the tif file to use irrelevant ? I'm using one from the testsuite:
from osgeo import gdal
inFilename = r"./output/python/plugins/processing/tests/data/raster.tif"
mylmg = gdal.Open(inFilename, gdal.GA_ReadOnly)
myBand = mylmg.GetRasterBand(1)
myData = myBand.ReadAsArray()
myData = None

myBand = None
mylmg = None

#10 - 2016-02-03 01:05 AM - Radoslaw Guzinski

I just tried with 2.12.3 and the latest nightly build (up to commit 0a64c16) with raster.tif and the issue is still present in both cases. It's a clean install on

Windows 7 using OSGeo4W 64 bit installer.

| don't have the build environment set up so | haven't tested the pull request but | will try to give it a go.

#11 - 2016-02-03 01:21 AM - Casper Borgesen
Radoslaw Guzinski wrote:

1 just tried with 2.12.3 and the latest nightly build (up to commit 0a64c16) with raster.tif and the issue is still present in both cases. It's a clean install

on Windows 7 using OSGeo4W 64 bit installer.

| have the same result on the latest nightly build (0a64c16).

#12 - 2016-04-09 11:53 PM - Giovanni Manghi
- Status changed from Feedback to Open

#13 - 2016-05-21 11:55 AM - Giovanni Manghi

this is still an issue on the latest master (tested on windows).

#14 - 2016-06-26 04:21 AM - Matthias Kuhn

Can't reproduce on latest master / Fedora.

#15 - 2016-06-26 12:03 PM - Nyall Dawson

Matthias - I've only been able to reproduce this under Windows.
#16 - 2016-09-21 12:55 AM - Giovanni Manghi

see also: #14648

it affects also a few Processing tools.

#17 - 2017-03-07 08:46 AM - Giovanni Manghi

- Status changed from Open to Feedback

- Target version set to Version 2.18
- Affected QGIS version changed from master to 2.18.4

This still affects 2.18.4, but what about qgis3 master?

#18 - 2017-04-30 09:51 AM - Giovanni Manghi

- Status changed from Feedback to Open

- Description updated

- Affected QGIS version changed from 2.18.4 to 2.18.7
#19 - 2017-05-01 01:07 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#20 - 2017-05-23 02:08 PM - Radoslaw Guzinski

Just tested with GDAL 2.2.0 on Windows: the issue is still present in 2.18.8 but | couldn't reproduce it with latest 2.99 nightly (d55fa22).

#21 - 2017-08-13 05:25 PM - Andreas Ekstrand

I'm also having this problem with gdal_merge.py from QGIS 2.18.11 64-bit on Win10. It's a real show-stopper for me since it's blocking my scripting.

#22 - 2017-08-13 06:03 PM - Giovanni Manghi
- Affected QGIS version changed from 2.18.7 to 2.18.11

Andreas Ekstrand wrote:

I'm also having this problem with gdal_merge.py from QGIS 2.18.11 64-bit on Win10. It's a real show-stopper for me since it's blocking my scripting.

Please raise your concerns about this long standing issue in the developers mailing list, at some point someone will need to have a look at it or support the
work to have a look at it and fix it.

#23 - 2017-08-13 11:14 PM - Jiirgen Fischer

Probably a duplicate of OSGeo4W #466

2025-06-08 4/5


https://trac.osgeo.org/osgeo4w/ticket/466

#24 - 2017-08-15 09:23 AM - Giovanni Manghi
- Resolution set to fixed/implemented
- Status changed from Open to Closed

Jurgen Fischer wrote:

Probably a duplicate of OSGeo4W #466

after the osgeo4w/gdal update no more crashes. Also there were a few plugins (like Lecos) that | believe were making ggis crash on exit that now do not

make it crash anymore.

#25 - 2017-08-16 09:37 AM - Radoslaw Guzinski

| confirm that the issue was fixed by the gdal update. Thanks Jurgen!
